/* -------------------------------------------------------------
This applet shows how overriding a method can change its 
behavior. It also shows how to invoke the behavior that's
defined in the superclass for an object.

Java's classes: Applet    (applet)
                System    (lang)

Custom classes: TriangleApplet
                Triangle

------------------------------------------------------------- */

public class TriangleApplet extends java.applet.Applet {

   public void init() {
   
      Triangle t1 = new Triangle();
      t1.base = 10;
      t1.height = 20;
   
      Triangle t2 = new Triangle();
      t2.base = 10;
      t2.height = 20;
   
      Triangle t3 = new Triangle();
      t3.base = 12;
      t3.height = 52;

      System.out.println("The triangles say:");
      System.out.println("t1 == t2? " + t1.equals(t2));
      System.out.println("t1 == t3? " + t1.equals(t3));
      
      System.out.println("The objects say:");
      System.out.println("t1 == t2? " + t1.objectEquals(t2));
      System.out.println("t1 == t3? " + t1.objectEquals(t3));
      
   }

}


class Triangle {
   int base;
   int height;
   
   public boolean equals(Object obj) {
      Triangle t;
   
      if (obj instanceof Triangle) {  
       
         t = (Triangle)obj;    
         if (t.base == base && t.height == height)
             return true;       
       }    
       
       return false;
   }

  boolean objectEquals(Object obj) {
      return super.equals(obj);   
   }

}