/* -------------------------------------------------------------
This applet creates circles using different constructors. One
of these constructors throws an exception.

Java's classes: Applet    (applet)
                System    (lang)   
                Exception (lang)

Custom classes: Constructor
                Circle          
                ImaginaryCircleException   

------------------------------------------------------------- */

import java.applet.Applet;

public class ExceptionApplet extends Applet {
   public void init() {
      Circle c1, c2, c3, c4;
      
      c1 = new Circle();
      
      try {
         c2 = new Circle(20);
      } catch (ImaginaryCircleException e) {
         System.out.println("Exception with radius 20");
         c2 = new Circle();
      }
      
      try {
         c3 = new Circle(-20);
      } catch (ImaginaryCircleException e) {
         System.out.println("Exception with radius -20");
         c3 = new Circle();
      }

      c4 = new Circle(c2);
      
      c1.displayInfo();
      c2.displayInfo();
      c3.displayInfo();
      c4.displayInfo();
   }  
}

class Circle {
   static int defaultRadius = 10;
   int radius;
   
   Circle() {
      radius = defaultRadius;
   }
   
   Circle(int radius) throws ImaginaryCircleException {
      if (radius < 0) 
         throw new ImaginaryCircleException();
      else
         this.radius = radius;
   }
   
   Circle(Circle referenceCircle) {
      this.radius = referenceCircle.radius;
   }

   void displayInfo() {
      System.out.println("This circle's radius is " + radius);
   }
}

class ImaginaryCircleException extends Exception {
}
